#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <math.h>

#include "../map_exec_type.c"
char pr_flag;char pr_next
#define fdprintf(f,fd,...) if(pr_flag>=f)dprintf(fd,##__VA_ARGS__)

#define strdupf(...) ({size_t s1=snprintf(NULL,0,##__VA_ARGS__);char *s=malloc(sizeof(char)*(s1+1));snprintf(s,s1+1,##__VA_ARGS__);s;})
#define freez(er) ({free(er);er=NULL;})
#define strchr1(s,c) ((c)=='\0'?NULL:strchr(s,c))
typedef long long llong
#define __local__ __label__
/*inline int iabs(int x)//-O3
	return abs(x)
#define abs(x) aabs(x)*/
#define fabs(x) fabs(x)
#define iabs(x) abs(x)
#define check_rect(rx,ry,rw,rh,x,y) (((rx)<(x)&&(x)<(rx)+(rw))&&((ry)<(y)&&(y)<(ry)+(rh)))
ssize_t read_int_sock(int fd,int *aval1)
	static int le_v=1;char *le=(char *)&le_v
	ssize_t out=read(fd,aval1,sizeof(int));if(*le)
		char *val=(char *)aval1;int n=0,n1=sizeof(int),n2=n1/2;n1-=1;while(n<n2)
			char tmp=val[n];val[n]=val[n1-n];val[n1-n]=tmp;n+=1
	return out
void write_int_sock(int fd,int val1)
	static int le_v=1;char *le=(char *)&le_v;if(*le)
		char *val=(char *)&val1;int n=0,n1=sizeof(int),n2=n1/2;n1-=1;while(n<n2)
			char tmp=val[n];val[n]=val[n1-n];val[n1-n]=tmp;n+=1
	write(fd,&val1,sizeof(int))

int angle2(/*p1+(1,0),*/int p1[2],int p2[2])/*-y*/
	double aa=atan2(-(p2[1]-p1[1]),p2[0]-p1[0])*180/M_PI;return aa*100
int angle1(/*(1,0),(0,0),*/int p1[2])
	double aa=atan2(p1[1],p1[0])*180/M_PI;return aa*100

int *vect1(int *out,int *p1,int *p2)
	out[0]=p2[0]-p1[0];out[1]=p2[1]-p1[1];return out
int *vect2(int *out,int x,int y)
	out[0]=x;out[1]=y;return out
//int vect1a(int *out,int aa)
//	out[0]=cos(((double)aa)/100)*100;out[1]=sin(((double)aa)/100)*100;return out
int vect_len(int *v1)
#define scale_vect vect_scale
#define vect_scale vect_scale_1
//#define vect_scale vect_scale_2
int *vect_scale(int *out,int *v1,int len2)
int *vect_scale_1(int *out,int *v1,int len2)
	int len1=vect_len(v1)
	if(len1==0){out[0]=len2;out[1]=0;};
	else{out[0]=v1[0]*len2/len1;out[1]=v1[1]*len2/len1
	/*int err=len2-vect_len(out);if(err)dprintf(2,"vect_scale_1/err %d\n",err);*/}return out
int *vect_scale_2a(int *out,int *v1,int len2)
	int len3
	dprintf(2,"len2 %d\n",len2)
	vect_scale(out,v1,len2);len3=vect_len(out)
	dprintf(2,"len3 %d\n",len3);int n=1;while(len3>len2)
		vect_scale(out,v1,len2-n);len3=vect_len(out);n+=1
	dprintf(2,"len3 %d %d\n",len3,n-1)
	return out
int *vect_scale_2(int *out,int *v1,int len2)
	int len1=vect_len(v1)
	if(len1==0){out[0]=len2;out[1]=0;};
	else{
	#define div1(a,b) (a?a/b:0)/*sgn()*/
	int s1=div1(v1[1],iabs(v1[1]))*div1(len2,iabs(len2))
	#undef div1
	out[0]=v1[0]*len2/len1
	//llong val2=len2*len2-out[0]*out[0]
	//llong val3=val2-(v1[1]*len2/len1)*(v1[1]*len2/len1)
	//dprintf(2,"a %llx %s%llx\n",val2,(val3<0?"-":""),llabs(val3))
	out[1]=s1*sqrt(len2*len2-out[0]*out[0])
	/*int err=len2-vect_len(out);if(err)dprintf(2,"vect_scale_2/err %d\n",err);*/}return out
	//out[1]=v1[1]*len2/len1
	//len2^2=out[0]^2+out[1]^2
int *vect_scale_d(int *out,int *v1,int len2)
	int len1=vect_len(v1);int alen2=iabs(len2)/*sgn(len2)*/
	if(len1<=alen2){out[0]=v1[0]*len2/alen2;out[1]=v1[1]*len2/alen2;};
	else{out[0]=v1[0]*len2/len1;out[1]=v1[1]*len2/len1;}return out
int *perp_vect(int *out,int *v1)/*-y x2*/
	int tmp0=-v1[0];out[0]=-(-v1[1]);out[1]=tmp0;return out
int *opp_vect(int *out,int *v1)
	out[0]=-v1[0];out[1]=-v1[1];return out
#define vect_set set_vect
int *set_vect(int *out,int *v1)
	out[0]=v1[0];out[1]=v1[1];return out
int *vect_add(int *out,int *v1,int *v2)
	out[0]=v1[0]+v2[0];out[1]=v1[1]+v2[1];return out
int *vect_sub(int *out,int *v1,int *v2)
	out[0]=v1[0]-v2[0];out[1]=v1[1]-v2[1];return out
int *vect_mult2(int *out,int *v1,int fact_1,int div_1)
	out[0]=v1[0]*fact_1/div_1;out[1]=v1[1]*fact_1/div_1;return out
int vect_len(int *v1)
	return sqrt(v1[0]*v1[0]+v1[1]*v1[1])
void vect_decom(int *out_x,int *out_y,int *v_x,int *v)
	int m_n=(v[0]*v_x[0]+v[1]*v_x[1]);int m_d=(v_x[0]*v_x[0]+v_x[1]*v_x[1]);int out2_x[2]
	out2_x[0]=v_x[0]*m_n/m_d;out2_x[1]=v_x[1]*m_n/m_d;vect_sub(out_y,v,out2_x)
	out_x[0]=out2_x[0];out_x[1]=out2_x[1]
int *vect_rot(int *out,int *v_x,int *v)
	int len1=vect_len(v_x);int v_y[2],out2[2];perp_vect(v_y,v_x)
	out2[0]=(v[0]*v_x[0]+v[1]*v_y[0])/len1;out2[1]=(v[0]*v_x[1]+v[1]*v_y[1])/len1
	out[0]=out2[0];out[1]=out2[1];return out

void curve_v1(int *ax1,int *v1,int *v2,int len0)
	int len1=vect_len(v1),len2=vect_len(v2);int tmp3[2],tmp4[2];int v0[2];int s1
	const char opt1=0/*if 0 orig. len.*/,opt2=1/*orig. angle*/
	if(len1!=len2)fdprintf(2,2,"len %d,%d,%d\n",len0,len1,len2)
	if(len1==len2)
		vect_add(ax1+0,ax1+0,v1);vect_add(ax1+2,ax1+2,v2)
	else if(len1<len2)
		if(1)
			vect_add(tmp3,v1,perp_vect(tmp3,vect1(v0,ax1+0,ax1+2)))
			if(vect_len(tmp3)<len0+len1)s1=-1;else s1=1
		vect_add(ax1+2,ax1+2,v2)
		if(opt2)
			vect_add(tmp4,ax1+0,v1)
			scale_vect(tmp4,vect1(tmp3,tmp4,ax1+2),len0)
		double a_1=(double)/*len1/len2*/len1*100/(len1+len2)/50,a_2=1-a_1
		//double a_1=0.999,a_2=1-a_1
		double x=opt1?len1:sqrt(len1*len1/(a_1*a_1+a_2*a_2))
		vect_add(ax1+0,ax1+0,vect_scale(tmp3,v1,x*a_1))
		vect_add(ax1+0,ax1+0,vect_scale(tmp3,perp_vect(tmp3,v1),x*a_2*s1))
		if(!opt2)scale_vect(tmp4,vect1(tmp3,ax1+0,ax1+2),len0)
		vect_add(ax1+2,ax1+0,tmp4)
	else if(len1>len2)
		if(1)
			vect_add(tmp3,v2,perp_vect(tmp3,vect1(v0,ax1+0,ax1+2)))
			if(vect_len(tmp3)<len0+len2)s1=-1;else s1=1
		vect_add(ax1+0,ax1+0,v1)
		if(opt2)
			vect_add(tmp4,ax1+2,v2)
			scale_vect(tmp4,vect1(tmp3,ax1+0,tmp4),-len0)
		double a_1=(double)/*len2/len1*/len2*100/(len1+len2)/50,a_2=-(1-a_1)
		//double a_1=0.999,a_2=-(1-a_1)
		double x=opt1?len2:sqrt(len2*len2/(a_1*a_1+a_2*a_2))
		vect_add(ax1+2,ax1+2,vect_scale(tmp3,v2,x*a_1))
		vect_add(ax1+2,ax1+2,vect_scale(tmp3,perp_vect(tmp3,v2),x*a_2*s1))
		if(!opt2)scale_vect(tmp4,vect1(tmp3,ax1+0,ax1+2),-len0)
		vect_add(ax1+0,ax1+2,tmp4)
inline int steer_f(int x)
	int val=10*10*10;return (x*x*x+val)*50/val

int v_wm[]={60/*mph*/,0,0}/*x2,*100*/
int steer[]={0,10};int steer0=50
int front[4]/*px*100*/
int front2[4]/*left,right,center point*/
//,y=32, (bk)
//x=14,30 13 3 6,x=20
//40 5 25 41
unsigned char dir_state=0/*frbl down*/
#include "main2.c"
void make_map()
	int tmp1[2]
	front[0]=(640-10)*100/2;front[1]=(480-10)*100/2;front[2]=front[0]+10*100;front[3]=front[1]
	//vect_add(front+2,front+0,scale_vect(tmp1,vect1(tmp1,front+0,front+2),10*100))
void update_map()
	unsigned char dir_state2=dir_state
	if(dir_state&0b0101);else
		if(-2<=steer[0]&&steer[0]<=2)
			if(steer[0]>0)dir_state2|=0b0001;else if(steer[0]<0)dir_state2|=0b0100
	if(dir_state2&0b0101)
		if(dir_state2&0b0001/*l*/)
			steer0+=-10;if(steer0<0)
				steer0=100
				steer[0]+=-1;if(steer[0]<-10)steer[0]=-10;steer[1]=10-iabs(steer[0])
		if(dir_state2&0b0100/*r*/)
			steer0+=10;if(steer0>=100)
				steer0=0
				steer[0]+=1;if(steer[0]>10)steer[0]=10;steer[1]=10-iabs(steer[0])
	if(steer[0])fdprintf(2,2,"steer %d %d\n",steer[0],steer[1])
	int tmp1[2],tmp2[2];if(1)
		if(dir_state&0b1000/*f*/)
			vect_add(tmp1,v_wm+1,perp_vect(tmp1,scale_vect(tmp1,vect1(tmp1,front+0,front+2),100)))
			if(vect_len(tmp1)<=v_wm[0]*100)set_vect(v_wm+1,tmp1)
		if(dir_state&0b0010/*b*/)
			vect_add(tmp1,v_wm+1,perp_vect(tmp1,scale_vect(tmp1,vect1(tmp1,front+0,front+2),-100)))
			if(vect_len(tmp1)<=v_wm[0]*100)set_vect(v_wm+1,tmp1)
	int tmp_x[2],tmp_y[2];int v_adjust[2]={0,0};int v_wm2[2];vect_mult2(v_wm2,v_wm+1,1*2,100)
	vect_decom(tmp_x,tmp_y,vect1(tmp1,front+0,front+2),v_wm2)
	const int steer_w=20;int bk[4]/*,fr[4]*/
	if(1&&vect_len(tmp_x)>20)
		//vect_add(front+0,front+0,perp_vect(tmp1,tmp_x));vect_add(front+2,front+2,tmp1)
		//vect_add(front+0,front+0,vect_mult2(tmp2,perp_vect(tmp1,tmp_x),steer[0]+10,steer_w));vect_add(front+2,front+2,vect_mult2(tmp2,tmp1,10-steer[0],steer_w))
		int tmp3[2],p1[4]
		//vect_mult2(tmp1,perp_vect(tmp3,tmp_x),steer[0]+10,steer_w)
		//vect_mult2(tmp2,tmp3,10-steer[0],steer_w)
		vect_mult2(p1+0,vect_add(tmp1,front+0,front+2),1,2)
		vect_add(bk+0,front+0,vect_scale(tmp1,perp_vect(tmp1,vect1(tmp1,front+0,front+2)),-(32-13)*100))
		vect_add(bk+2,front+2,vect_scale(tmp1,perp_vect(tmp1,vect1(tmp1,front+0,front+2)),-(32-13)*100))
		vect_mult2(p1+2,vect_add(tmp1,bk+0,bk+2),1,2)
		curve_v1(p1,vect_mult2(tmp1,tmp_x,1,3),vect_mult2(tmp2,tmp_x,2,3),(32-13)*100)
		perp_vect(tmp1,vect1(tmp1,p1+0,p1+2))
		vect_add(front+0,p1+0,vect_scale(tmp2,tmp1,-10*100/2))
		vect_add(front+2,p1+0,vect_scale(tmp2,tmp1,10*100/2))
		vect_add(v_adjust,v_adjust,vect_scale_d(tmp2,tmp_x,-100))
	else
		vect_scale(tmp_y,tmp_y,vect_len(v_wm2));set_vect(v_wm2,tmp_y)
		vect_scale_2(v_wm+1,tmp_y,vect_len(v_wm+1))
	fdprintf(2,2,"v_wm2 %d,%d\n",v_wm2[0],v_wm2[1])
	fdprintf(2,2,"decom %d,%d %d,%d\n",tmp_x[0],tmp_x[1],tmp_y[0],tmp_y[1])
	vect_add(bk+0,front+0,vect_scale(tmp1,perp_vect(tmp1,vect1(tmp1,front+0,front+2)),-(32-13)*100))
	vect_add(bk+2,front+2,vect_scale(tmp1,perp_vect(tmp1,vect1(tmp1,front+0,front+2)),-(32-13)*100))
	//vect_mult2(tmp1,tmp_y,steer[0]+10,steer_w);vect_mult2(tmp2,tmp_y,10-steer[0],steer_w)
	vect_mult2(tmp1,tmp_y,steer_f(steer[0]),100);vect_mult2(tmp2,tmp_y,steer_f(-steer[0]),100)
	curve_v1(bk,tmp1,tmp2,10*100)
	vect_add(front+0,bk+0,vect_scale(tmp1,perp_vect(tmp1,vect1(tmp1,bk+0,bk+2)),(32-13)*100))
	vect_add(front+2,bk+2,vect_scale(tmp1,perp_vect(tmp1,vect1(tmp1,bk+0,bk+2)),(32-13)*100))
	vect_add(v_adjust,v_adjust,vect_scale_d(tmp2,tmp_y,-20))
	fdprintf(2,2,"v_adjust %d,%d\n",v_adjust[0],v_adjust[1])
	vect_add(v_wm+1,v_wm+1,v_adjust);if(vect_len(v_wm+1)>v_wm[0]*100)scale_vect(v_wm+1,v_wm+1,v_wm[0]*100);//if(vect_len(v_wm+1)<40*40)vect2(v_wm+1,0,0)
	front2[0]=front[0]/100;front2[1]=front[1]/100;front2[2]=front[2]/100;front2[3]=front[3]/100
	//dprintf(2,"loc. %d,%d %d,%d\n",front2[0],front2[1],front2[2],front2[3])
void map_draw1(char *fn)
	write_1(3);write_1(0)/*clear_mod*/
	write_1(1);write_str(fn);write_int(0);write_int(0)
	main2_draw1(fn)

	write_1(8/*bound1*/);const int dim1=25;write_int((front2[0]+front2[2])/2-dim1);write_int((front2[1]+front2[3])/2-dim1);write_int(dim1*2);write_int(dim1*2)
	write_1(2);write_int(40);write_int(5);write_int(25);write_int(41);write_int(front2[0]-3/2-(20-14));write_int(front2[1]-6/2-(13-5));write_str("")
	int aa=angle2(front+0,front+2)
	write_1(10);write_int(aa);write_int(front2[0]);write_int(front2[1]);write_1(0)
	write_1(2);write_int(20);write_int(13);write_int(3);write_int(6);write_int(front2[0]-3/2);write_int(front2[1]-6/2);write_str("")
	int aa_2=angle1(steer)-90*100
	fdprintf(2,2,"aa %d %d\n",aa/100,aa_2/100)
	write_1(10);write_int(aa+aa_2);write_int(front2[0]);write_int(front2[1]);write_1(0)
	write_1(2);write_int(30);write_int(13);write_int(3);write_int(6);write_int(front2[2]-3/2);write_int(front2[3]-6/2);write_str("")
	write_1(10);write_int(aa+aa_2);write_int(front2[2]);write_int(front2[3]);write_1(0)

	write_1(3);write_1(1)/*end_mod*/
void set_pr_flag(signed char field)
	if(0)
		char *res=getenv("pr_flag");if(res)pr_flag=strtol(res,NULL,0/*base*/);else pr_flag=0
	if(1)
		char *res=getenv("pr_flag");if(res)
			char *res2=res,*res2_f=NULL;while(res2[0]){if(res2[0]=='.')break;res2+=1;}
			if(field==1)res2=res2_f=strndup(res,res2-res)
			else if(field==2)
				if(res2[0]=='.')res2=res2+1;else res2=res
			pr_flag=strtol(res2,NULL,0/*base*/);free(res2_f)
		else pr_flag=0
int main(int argc,char **argv)
	set_pr_flag(2)
	char var=read_1(),var2;if(var==1)var2=read_1()
	write_1(4);write_1(0);write_int(0xFFC0C0C0)/*bg_color*/
	//long flags=fcntl(F_GETFL,0);long res;if(flags!=-1)res=fcntl(F_SETFL,0,flags|O_NONBLOCK);if(flags==-1||res==-1)dprintf(2,"fl. err\n")
	char *fn=NULL;if(1<argc)fn=argv[1];else
		dprintf(2,"please provide the image filename\n");return 1
	
	write_1(7);write_1(1)/*send key-up/down*/
	make_map();char send_tick=1;write_1(6)
	while(1)
		char var=read_1();if(read_1_suc)
			char flag1=1
			if(var==2)
				int x=read_int(),y=read_int()
				char *id=read_str();int id_len=strlen(id);if(id_len>0)
					dprintf(2,"I click %s\n",id)
			else if(var==3)
				int sym=read_int(),mod=read_int();char down=(read_1()==0)
				if(down)
					if(sym==1073741882&&mod==4096)pr_next=(pr_next+1)%2/*F1*/
					else if(pr_next>0)
						dprintf(2,"I key %d %d\n",sym,mod)
				if(mod==4096)
					const int arrow=0x4000004F/*r,l,d,u*/
					char *rec_val1
					if(sym==arrow+0/*r*/)
						dir_state&=0b1011;if(down)dir_state|=0b0100
					else if(sym==arrow+1/*l*/)
						dir_state&=0b1110;if(down)dir_state|=0b0001
					else if(sym==arrow+2/*d*/)
						dir_state&=0b1101;if(down)dir_state|=0b0010
					else if(sym==arrow+3/*u*/)
						dir_state&=0b0111;if(down)dir_state|=0b1000
					else if(down&&sym==110/*n*/)
						if(!send_tick)flag1=0
					else if(down&&sym==112/*p*/)
						send_tick=(send_tick+1)%2;if(send_tick)write_1(6)
					else if(down)main2_key(sym,mod)
				if(down)
					if(mod==4160)/*ctrl*/
						main2_key(sym,mod)
			else if(var==6/*tick*/)flag1=0
			if(flag1)continue
		//usleep(200000/*200ms*/)
		update_map();map_draw1(fn);if(send_tick)write_1(6)
	return 0
//cpp.py main main2;gcc main.c -o main -lm -O0 -Wall|& gccw
//pr_flag=1 SDL_RENDER_DRIVER=software /root/lib-sdl2/../../../lib/i386*/ld-2.27.so `which map_exec` ./go/main ./go/*.png