#include <unistd.h>
int pipe2(int pipefd[2], int flags)
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>
#include <fcntl.h>
#include <errno.h>

#include "SDL.h"
#include "SDL_image.h"

#define max(a,b) ((a)>(b)?(a):(b))
#define min(a,b) ((a)<(b)?(a):(b))
#define fabs(x) fabs(x)
#define iabs(x) abs(x)

SDL_Window *window
SDL_Renderer *renderer

char app_done=0,redraw=0,refresh=0;char pr_flag;char show_grid=0

int fzoom=100 ;//100px shall be drawn as fzoom
SDL_Rect win_coord1
SDL_Rect win_abs ;//x,y is 0,0 always

int absx1(int cx,unsigned char fact_1)
	if(fact_1)return cx*fzoom/100+win_abs.w/2+win_coord1.x
	else return cx*fzoom/100
int absy1(int cy,unsigned char fact_1)
	if(fact_1)return cy*fzoom/100+win_abs.h/2+win_coord1.y
	else return cy*fzoom/100
int coordx1(int abx,unsigned char fact_1)
	if(fact_1)return (abx-win_abs.w/2-win_coord1.x)*100/fzoom
	else return (abx)*100/fzoom
int coordy1(int aby,unsigned char fact_1)
	if(fact_1)return (aby-win_abs.h/2-win_coord1.y)*100/fzoom
	else return (aby)*100/fzoom

void* sdl_v
#define sdl_(c,b,a,...) ({sdl_v=(void *)c##a(__VA_ARGS__);if((b>0&&sdl_v==NULL)||(b<=0&&((long)sdl_v)<b)){printf("SDL_%s failed: %s\n",#a, SDL_GetError());}sdl_v;})
#define sdl(b,a,...) sdl_(SDL_,b,a,__VA_ARGS__)

#define set_rect(r,x1,y1,w1,h1) (r).x=x1;(r).y=y1;(r).w=w1;(r).h=h1
#define rect_arg(r) (r).x,(r).y,(r).w,(r).h
#define check_rect(rx,ry,rw,rh,x,y) (((rx)<(x)&&(x)<(rx)+(rw))&&((ry)<(y)&&(y)<(ry)+(rh)))

#define dline1(a,b,c,d) sdl(0,RenderDrawLine,renderer,a,c,b,d)
#define dline(a,b,c,d) dline1(absx1(a,1),absx1(b,1),absy1(c,1),absy1(d,1))
void thick_line(int x1,int x2,int y1,int y2,int thn/*usually odd*/)
	int n;if(thn) dline(x1,x2,y1,y2)
	if(iabs(x1-x2)<=iabs(y1-y2))
		for(n=1;n<=thn/2;n+=1)
			dline(x1+n,x2+n,y1,y2) ;dline(x1-n,x2-n,y1,y2)
	else
		for(n=1;n<=thn/2;n+=1)
			dline(x1,x2,y1+n,y2+n) ;dline(x1,x2,y1-n,y2-n)

struct file
	char *fn;SDL_Texture* textu
	int b_x,b_y
;//
void file_init(struct file *file)
	file->textu=NULL
struct file *file_arr;int len_file_arr
int file_n;SDL_Rect dest_bound
struct area
	int off
	//int b_x,b_y
	int x,y,w,h,dest_x,dest_y;char *id;int file_n
	char del/*0 deleted 1-9 layer*/
;//
void area_init(struct area *area)
	area->del=1;area->file_n=file_n
struct area *area_arr;int len_area_arr,len_area_arr_2;int area_arr_n=-1
#define file1_set_mac(fn,b_x,b_y) ({char *a1=fn;int a2=b_x;int a3=b_y;file1_set(a1,a2,a3);})
void file1_set(char *fn,int b_x,int b_y)
	int n=0;while(n<len_file_arr)
		if(!strcmp(file_arr[n].fn,fn))break;n+=1
	struct file *file1=&file_arr[n]
	if(redraw==2)redraw=0
	if(n>=len_file_arr)
		len_file_arr+=1;file_arr=realloc(file_arr,sizeof(struct file)*len_file_arr)
		file1=&file_arr[n];file_init(file1)
		file1->fn=strdup(fn)
		file1->b_x=b_x;file1->b_y=b_y
	else if(file1->b_x!=b_x||file1->b_y!=b_y)
		file1->b_x=b_x;file1->b_y=b_y;redraw=1
	if(!file1->textu)
		SDL_Surface *tmp
		tmp=sdl_(IMG_,1,Load,file1->fn);if(tmp)
			file1->textu=sdl(1,CreateTextureFromSurface,renderer,tmp)
			SDL_FreeSurface(tmp)
			//SDL_DestroyTexture(file1->textu)
			if(pr_flag>=1)dprintf(2,"loaded %s\n",fn)
	file_n=n
//
#define map_add_area_mac(x,y,w,h,dest_x,dest_y,id) ({int a1=x;int a2=y;int a3=w;int a4=h;int a5=dest_x;int a6=dest_y;char *a7=id;map_add_area(a1,a2,a3,a4,a5,a6,a7);})
void map_add_area(int x,int y,int w,int h,int dest_x,int dest_y,char *id)
	int n=0,n_out=-1;while(n<len_area_arr_2)
		struct area *area1=&area_arr[n]
		if(area1->del==0){n_out=n;break;}n+=1
	if(n_out<0)
		n_out=len_area_arr_2
		len_area_arr_2+=1;area_arr=realloc(area_arr,sizeof(struct area)*len_area_arr_2)
	struct area *area1=&area_arr[n_out];area_init(area1)
	area1->x=x;area1->y=y;area1->w=w;area1->h=h;area1->dest_x=dest_x;area1->dest_y=dest_y;area1->id=id[0]=='\0'?NULL:strdup(id)
	area_arr_n=n_out
void map_move_area(char layer/*1-9*/)
	int n=area_arr_n
	if(n>=0)
		struct area *area1=&area_arr[n]
		if(area1->del!=0)area1->del=layer
void map_clear_area()
	int n=0;while(n<len_area_arr)
		struct area *area1=&area_arr[area_arr[n].off]
		if(area1->del!=0)
			free(area1->id);area1->del=0
		n+=1
void map_list_area()
	len_area_arr=0
	int n_2=1;while(1)
		char flag1=0
		int n=0;while(n<len_area_arr_2)
			struct area *area1=&area_arr[n]
			if(area1->del!=0)
				if(area1->del>n_2)flag1=1;else if(area1->del==n_2)
					struct area *area2=&area_arr[len_area_arr]
					area2->off=n;len_area_arr+=1
			n+=1
		if(flag1)n_2+=1;else break

int bg_color=0xFFFFFF,mg_color=0x333333,fg_color=0x000000
void set_color(int off,int c)
	if(off==0)bg_color=c;else if(off==1)mg_color=c;else if(off==2)fg_color=c;else dprintf(2,"invalid color off %d\n",off)
//
#define sdl_set_color(renderer,color) SDL_SetRenderDrawColor(renderer,(color>>8*2)&0xFF,(color>>8*1)&0xFF,(color>>8*0)&0xFF,/*a*/0xFF)
void draw_all()
	//SDL_RenderClear(renderer)
	sdl_set_color(renderer,bg_color);SDL_RenderFillRect(renderer,NULL)
	SDL_Rect src;SDL_Rect dest
	int n=0;while(n<len_area_arr)
		struct area *area1=&area_arr[area_arr[n].off]
		struct file *file1=&file_arr[area1->file_n]
		src.x=file1->b_x+area1->x;src.y=file1->b_y+area1->y;src.w=area1->w;src.h=area1->h
		dest.x=absx1(area1->dest_x,1);dest.y=absy1(area1->dest_y,1);dest.w=absx1(area1->w,0);dest.h=absy1(area1->h,0)
		//dprintf(2,"src %d %d %d %d\n",rect_arg(src))
		//dprintf(2,"dest %d %d %d %d\n",rect_arg(dest))
		if(file1->textu)SDL_RenderCopy(renderer,file1->textu,&src,&dest)
		else{sdl_set_color(renderer,mg_color);SDL_RenderFillRect(renderer,&dest);}
		n+=1
	if(show_grid)
		sdl_set_color(renderer,fg_color)
		int y,y_1=coordy1(0,1),y_2=coordy1(win_abs.h,1);while(y_1<y_2)
			y=absy1(y_1,1);dline1(0,win_abs.w,y,y);y_1+=1
		int x,x_1=coordx1(0,1),x_2=coordx1(win_abs.w,1);while(x_1<x_2)
			x=absx1(x_1,1);dline1(x,x,0,win_abs.h);x_1+=1
void script2(int xx,int yy)
	char test1=(!xx&&!yy)
	static int ww,hh;SDL_GetWindowSize(window,&ww,&hh)
	//if(ww!=win_abs.w||hh!=win_abs.h)
	win_abs.w=ww;win_abs.h=hh
	xx=-xx ;yy=-yy
	xx+=win_coord1.x ;yy+=win_coord1.y
	set_rect(win_coord1,xx,yy,coordx1(ww,0),coordy1(hh,0))

	if(test1);else {redraw=1;return;}
	set_rect(dest_bound,0,0,0,0);unsigned int total_a=0
	int n=0;while(n<len_area_arr)
		struct area *area1=&area_arr[area_arr[n].off]
		if(total_a<1||area1->dest_x<dest_bound.x)dest_bound.x=area1->dest_x
		if(total_a<1||area1->dest_y<dest_bound.y)dest_bound.y=area1->dest_y
		if(total_a<1||area1->dest_x+area1->w>dest_bound.w)dest_bound.w=area1->dest_x+area1->w
		if(total_a<1||area1->dest_y+area1->h>dest_bound.h)dest_bound.h=area1->dest_y+area1->h
		n+=1;total_a+=1
	dest_bound.w-=dest_bound.x;dest_bound.h-=dest_bound.y

	SDL_Rect bound=dest_bound
	SDL_Rect w
	set_rect(w,coordx1(0,1),coordy1(0,1),win_coord1.w,win_coord1.h)
	if(pr_flag>=3)
		dprintf(2,"dest_bound %d %d %d %d ,%d\n",rect_arg(dest_bound),total_a)
		dprintf(2,"w %d %d %d %d\n",rect_arg(w))
	if(total_a>0)
		if(w.x+w.w-bound.x<0)win_coord1.x+=absx1(w.x+w.w-bound.x,0)
		if(w.x-(bound.x+bound.w)>0)win_coord1.x+=absx1(w.x-(bound.x+bound.w),0)
		if(w.y+w.h-bound.y<0)win_coord1.y+=absy1(w.y+w.h-bound.y,0)
		if(w.y-(bound.y+bound.h)>0)win_coord1.y+=absy1(w.y-(bound.y+bound.h),0)
void scroll_f(SDL_Rect b1)
	//dprintf(2,"b1 %d %d %d %d\n",rect_arg(b1))
	//script1(-b1.w,-b1.h)
	script2(-b1.w,-b1.h)

int main_argc;char **main_argv
int fdin=-1,fd=-1
char read_1()
	char out;while(1)
		ssize_t s2=read(fdin,&out,1);if(s2<0);else if(s2==0);else break
	return out
int read_int()
	char buf[sizeof(int)];int sz_buf=sizeof(int);int len_buf=0
	while(1)
		ssize_t s1=read(fdin,buf+len_buf,min(sizeof(int),sz_buf-len_buf));if(s1<0)
		else if(s1==0)
		else
			len_buf+=s1;if(len_buf>=sz_buf)break
	int *out=(int *)buf
	if(pr_flag>=3)dprintf(2,"recv %d\n",out[0]);return out[0]
char *read_str()
	static char buf[512];int sz_buf=512;int len_buf=0;char end=0
	while(1)
		int len2=8-len_buf%8;if(len2==8&&end)break
		ssize_t s1=read(fdin,buf+len_buf,min(len2,sz_buf-0-len_buf));if(s1<0)
		else if(s1==0)
		else
			//len_buf+=s1
			ssize_t s2=0;while(s2<s1)
				char c=buf[len_buf+s2]
				if(c=='\r'||c=='\n')
					buf[len_buf+s2]='\0';end=1
				s2+=1
			len_buf+=s1
			if(len_buf>=sz_buf-0)len_buf=0
	if(pr_flag>=3)dprintf(2,"recv %s\n",buf);return buf
void write_1(char val)
	ssize_t s1=write(fd,&val,1)
void write_int(int val)
	ssize_t s1=write(fd,&val,sizeof(int))
	if(pr_flag>=3)dprintf(2,"sent %d\n",val)
void write_str(char *str)
	char *str1=str,*str_f=NULL,*res
	int off=0,len_str=strlen(str)
	while(1)
		res=strchr(str,'\n');if(!res)break
		if(!str_f){str_f=str=strdup(str);res=strchr(str,'\n');}res[0]=' '
	while(off<len_str)
		ssize_t s1=write(fd,str+off,min(64,len_str-off));if(s1<0)
		else if(s1==0)
		else
			off+=s1
	if(1)
		write(fd,"\n",1);int len2=(8-(len_str+1)%8)%8;if(len2)
			char *a=malloc(sizeof(char)*len2);memset(a,' ',len2);write(fd,a,len2);free(a)
	if(pr_flag>=3)dprintf(2,"sent %s\n",str);free(str_f)
void setup_comm(char arg)
	static pid_t ev_pid=0;static int pipefd[2],pipefdin[2];int res,ex
	if(ev_pid&&arg==2)
		kill(ev_pid,SIGTERM);if(pr_flag>=1)dprintf(2,"\nending")
	if(ev_pid&&waitpid(ev_pid,&ex,(arg==2)?0:WNOHANG)>0&&kill(ev_pid,0)==-1)
		close(pipefd[1]);fd=-1;close(pipefdin[0]);fdin=-1;ev_pid=0
	if(ev_pid==0)
		res=pipe(pipefd);res=pipe2(pipefdin,O_NONBLOCK)
		//long flags=fcntl(F_GETFL,pipefdin[0]);if(flags!=-1)res=fcntl(F_SETFL,pipefdin[0],flags|O_NONBLOCK);if(flags==-1||res==-1)dprintf(2,"fl. err\n")
		ev_pid=fork()
		if(ev_pid==(pid_t)-1)
			close(pipefd[0]);close(pipefd[1])
			close(pipefdin[0]);close(pipefdin[1]);ev_pid=0
		else if(!ev_pid)
			close(pipefd[1]);dup2(pipefd[0],0)
			close(pipefdin[0]);dup2(pipefdin[1],1)
			SDL_Quit()
			if(1<main_argc&&execvp((main_argv+1)[0],main_argv+1)==-1)
				dprintf(2,"exec %s\n",strerror(errno))
			_Exit(1)
		else
			if(pr_flag>=1)dprintf(2,"\nlaunching\n")
			close(pipefd[0]);fd=pipefd[1]
			close(pipefdin[1]);fdin=pipefdin[0]
			if(fd>=0)
				char cmd[]={1,arg};write(fd,cmd,2)

char flag_2=0
char check_comm()
	if(flag_2)return 0
	if(fdin>=0);else return 0
	static char mod_mode
	char cmd;ssize_t s1=read(fdin,&cmd,1);if(s1<0)
	else if(s1==0)
	else
		if(pr_flag>=3)dprintf(2,"got %d\n",cmd)
		if(!redraw)redraw=2
		if(cmd==1)file1_set_mac(read_str(),read_int(),read_int())
		else if(cmd==2)map_add_area_mac(read_int(),read_int(),read_int(),read_int(),read_int(),read_int(),read_str())
		else if(cmd==3)
			/*0 clear_area,begin mod. 1 end mod.,screen refresh
			2 move_area(2) 3 ignored 4 begin mod. 5 del 6-14 move_area(1-9)*/
			char op=read_1();if(op==0||op==4)mod_mode=1;char test1=0
			if(op==0)map_clear_area()
			else if(op==2)map_move_area(2)
			else if(op==5)
			else if(6<=op&&op<=14){map_move_area(op-4);test1=1;}
			if(op==0||op==2||op==5||test1);else if(redraw==2)redraw=0
			if(op==1)
				map_list_area();mod_mode=0;return 0/*screen refresh*/
		else if(cmd==4)
			unsigned char off=read_1();set_color(off,read_int())
		else if(cmd==5)/*ignore*/
		else if(cmd==6)/*received tick*/
			write_1(6)/*send tick*/;if(redraw==2)redraw=0
		//if(cmd==2)flag_2=1
		if(redraw==2)redraw=1;return 1
	return mod_mode

void comm_key(char cmd,int sym,int mod)
	write(fd,&cmd,1);write_int(sym);write_int(mod)
void comm_click(char cmd,int x1,int y1)
	int x=coordx1(x1,1),y=coordy1(y1,1)
	//dprintf(2,"click %d %d %d %d\n",x1,y1,x,y)
	int n=0;while(n<len_area_arr)
		struct area *area1=&area_arr[area_arr[n].off]
		if(check_rect(area1->dest_x,area1->dest_y,area1->w,area1->h,x,y))
			write(fd,&cmd,1);write_int(x-area1->dest_x);write_int(y-area1->dest_y);write_str(area1->id?area1->id:"")
		n+=1

//#include "windowevent.c"
void CheckWEvent(const SDL_Event *ev)
	if(ev->type==SDL_WINDOWEVENT);else return
	if(ev->window.event==SDL_WINDOWEVENT_EXPOSED)
		refresh=1
	else if(ev->window.event==SDL_WINDOWEVENT_RESIZED)
		//resizef(ev->window.data1,ev->window.data2)
		redraw=1
int prev_x,prev_y
void CheckBEvent(SDL_Event *ev)
	if(ev->type==SDL_MOUSEBUTTONDOWN||ev->type==SDL_MOUSEBUTTONUP);else return
	SDL_MouseButtonEvent *info=&ev->button
	static int down;down=(info->type==SDL_MOUSEBUTTONDOWN)
	SDL_Keymod mod=SDL_GetModState()
	if(info->button==SDL_BUTTON_LEFT)
		//printf("%d down\n",down)
		if(mod&KMOD_CTRL)
			static SDL_Rect b1
			if(down){b1.x=info->x;b1.y=info->y;};
			else{b1.w=info->x-b1.x;b1.h=info->y-b1.y
			static int ta,tb; ta=abs(b1.w)<30 ;tb=abs(b1.h)<30
			if(ta&&!tb)b1.w=0;if(tb&&!ta)b1.h=0
			if(b1.w||b1.h){scroll_f(b1);}}
		else if(down)
			setup_comm(1);if(fd>=0)
				comm_click(2,info->x,info->y)
			prev_x=info->x;prev_y=info->y
	if(info->button==SDL_BUTTON_MIDDLE)
		//if(down)actionf(info->x,info->y)
void CheckKEvent(SDL_Event *ev)
	if(ev->type==SDL_KEYDOWN||ev->type==SDL_KEYUP);else return
	SDL_KeyboardEvent *info=&ev->key
	static int down;down=(info->type==SDL_KEYDOWN)
	SDL_Keycode sym ;if(info) sym=info->keysym.sym
	Uint16 mod ;if(info) mod=info->keysym.mod
	//if(!mod&KMOD_SHIFT)
	//if(sym==SDLK_RETURN)
	if(down);else return
	int oldfzoom=fzoom
	if(1)
		if(sym==SDLK_q)
			if(mod&KMOD_CTRL)setup_comm(2)
			else app_done=1
		else if(sym==SDLK_g){show_grid=(show_grid+1)%2;redraw=1;};
		else if(sym==SDLK_c)
			if(mod&KMOD_SHIFT)script2(win_abs.w/2-prev_x,win_abs.h/2-prev_y)
			else script2(prev_x-win_abs.w/2,prev_y-win_abs.h/2)
		else if(sym==SDLK_z)
			if(win_abs.h*iabs(prev_x-win_abs.w/2)>win_abs.w*iabs(prev_y-win_abs.h/2))fzoom=oldfzoom*win_abs.w/(2*iabs(prev_x-win_abs.w/2))
			else fzoom=oldfzoom*win_abs.h/(2*iabs(prev_y-win_abs.h/2))
		else if(sym==SDLK_y)
			if(win_abs.h*iabs(prev_x-win_abs.w/2)>win_abs.w*iabs(prev_y-win_abs.h/2))fzoom=oldfzoom*(2*iabs(prev_x-win_abs.w/2))/win_abs.w
			else fzoom=oldfzoom*(2*iabs(prev_y-win_abs.h/2))/win_abs.h
	if(mod&KMOD_CTRL)
		if(sym==SDLK_EQUALS)fzoom=min(oldfzoom/10*10+10,(unsigned int)-1/2)
		else if(sym==SDLK_MINUS)fzoom=max(1,oldfzoom/10*10-10)
		else if(sym==SDLK_0)fzoom=100
	if(fzoom!=oldfzoom)
		win_coord1.x=win_coord1.x*fzoom/oldfzoom
		win_coord1.y=win_coord1.y*fzoom/oldfzoom
		redraw=1;//script2(0,0)
	setup_comm(1);if(fd>=0)
		comm_key(3,sym,mod)

void set_pr_flag(signed char field)
	if(0)
		char *res=getenv("pr_flag");if(res)pr_flag=strtol(res,NULL,0/*base*/);else pr_flag=0
	if(1)
		char *res=getenv("pr_flag");if(res)
			char *res2=res,*res2_f=NULL;while(res2[0]){if(res2[0]=='.')break;res2+=1;}
			if(field==1)res2=res2_f=strndup(res,res2-res)
			else if(field==2)
				if(res2[0]=='.')res2=res2+1;else res2=res
			pr_flag=strtol(res2,NULL,0/*base*/);free(res2_f)
		else pr_flag=0
int main(int argc, char **argv)
	main_argc=argc;main_argv=argv;set_pr_flag(1)
	SDL_Event ev

	SDL_LogSetPriority(SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_INFO)
	sdl(0,Init,SDL_INIT_EVENTS/*|SDL_INIT_NOPARACHUTE*/);// Event Handling, File I/O, and Threading subsystems are initialized by default
	SDL_bool did_set=SDL_SetHint(SDL_HINT_RENDER_DRIVER,"software")
	if(did_set)
		printf("set software render hint\n");fflush(stdout)

	int w=640,h=480;redraw=1
	win_coord1.x=-w/2;win_coord1.y=-h/2
	//sdl(0,CreateWindowAndRenderer(w, h, 0, &window, &renderer)
	window=sdl(1,CreateWindow,NULL, SDL_WINDOWPOS_UNDEFINED,SDL_WINDOWPOS_UNDEFINED, w,h, SDL_WINDOW_RESIZABLE)
	//SDL_SetWindowPosition(window,0,40)
	renderer = sdl(1,CreateRenderer,window,-1,0/*SDL_RENDERER_SOFTWARE/_ACCELERATED*//*|SDL_RENDERER_TARGETTEXTURE*/)

	//script1(0,0)
	setup_comm(0)
	while(1)
		char flag1=0
		while(SDL_PollEvent(&ev))
			flag1=1
			if(ev.type==SDL_QUIT)app_done=1
			CheckWEvent(&ev)
			CheckBEvent(&ev)
			CheckKEvent(&ev)
		while(check_comm())flag1=1
		if(redraw)
			refresh=1;script2(0,0);draw_all();redraw=0
		if(refresh)
			SDL_RenderPresent(renderer);refresh=0
		if(app_done)break;else if(flag1==0)usleep(2000/*2ms*/)
	return 0
